diff --git a/src/backend/access/common/heaptuple.c b/src/backend/access/common/heaptuple.c
index 503cda46ef..4e61b6b372 100644
--- a/src/backend/access/common/heaptuple.c
+++ b/src/backend/access/common/heaptuple.c
@@ -82,14 +82,14 @@
  */
 Datum
 getmissingattr(TupleDesc tupleDesc,
-			   int attnum, bool *isnull)
+			   int attphysnum, bool *isnull)
 {
 	Form_pg_attribute att;
 
-	Assert(attnum <= tupleDesc->natts);
-	Assert(attnum > 0);
+	Assert(attphysnum <= tupleDesc->natts);
+	Assert(attphysnum > 0);
 
-	att = TupleDescAttr(tupleDesc, attnum - 1);
+	att = TupleDescAttr(tupleDesc, attphysnum - 1);
 
 	if (att->atthasmissing)
 	{
@@ -98,7 +98,7 @@ getmissingattr(TupleDesc tupleDesc,
 		Assert(tupleDesc->constr);
 		Assert(tupleDesc->constr->missing);
 
-		attrmiss = tupleDesc->constr->missing + (attnum - 1);
+		attrmiss = tupleDesc->constr->missing + (attphysnum - 1);
 
 		if (attrmiss->am_present)
 		{
@@ -356,29 +356,29 @@ heap_fill_tuple(TupleDesc tupleDesc,
  * ----------------
  */
 bool
-heap_attisnull(HeapTuple tup, int attnum, TupleDesc tupleDesc)
+heap_attisnull(HeapTuple tup, int attphysnum, TupleDesc tupleDesc)
 {
 	/*
 	 * We allow a NULL tupledesc for relations not expected to have missing
 	 * values, such as catalog relations and indexes.
 	 */
-	Assert(!tupleDesc || attnum <= tupleDesc->natts);
-	if (attnum > (int) HeapTupleHeaderGetNatts(tup->t_data))
+	Assert(!tupleDesc || attphysnum <= tupleDesc->natts);
+	if (attphysnum > (int) HeapTupleHeaderGetNatts(tup->t_data))
 	{
-		if (tupleDesc && TupleDescAttr(tupleDesc, attnum - 1)->atthasmissing)
+		if (tupleDesc && TupleDescAttr(tupleDesc, attphysnum - 1)->atthasmissing)
 			return false;
 		else
 			return true;
 	}
 
-	if (attnum > 0)
+	if (attphysnum > 0)
 	{
 		if (HeapTupleNoNulls(tup))
 			return false;
-		return att_isnull(attnum - 1, tup->t_data->t_bits);
+		return att_isnull(attphysnum - 1, tup->t_data->t_bits);
 	}
 
-	switch (attnum)
+	switch (attphysnum)
 	{
 		case TableOidAttributeNumber:
 		case SelfItemPointerAttributeNumber:
@@ -390,7 +390,7 @@ heap_attisnull(HeapTuple tup, int attnum, TupleDesc tupleDesc)
 			break;
 
 		default:
-			elog(ERROR, "invalid attnum: %d", attnum);
+			elog(ERROR, "invalid attphysnum: %d", attphysnum);
 	}
 
 	return false;
@@ -421,7 +421,7 @@ heap_attisnull(HeapTuple tup, int attnum, TupleDesc tupleDesc)
  */
 Datum
 nocachegetattr(HeapTuple tuple,
-			   int attnum,
+			   int attphysnum,
 			   TupleDesc tupleDesc)
 {
 	HeapTupleHeader tup = tuple->t_data;
@@ -439,7 +439,7 @@ nocachegetattr(HeapTuple tuple,
 	 * ----------------
 	 */
 
-	attnum--;
+	attphysnum--;
 
 	if (!HeapTupleNoNulls(tuple))
 	{
@@ -448,8 +448,8 @@ nocachegetattr(HeapTuple tuple,
 		 *
 		 * check to see if any preceding bits are null...
 		 */
-		int			byte = attnum >> 3;
-		int			finalbit = attnum & 0x07;
+		int			byte = attphysnum >> 3;
+		int			finalbit = attphysnum & 0x07;
 
 		/* check for nulls "before" final bit of last byte */
 		if ((~bp[byte]) & ((1 << finalbit) - 1))
@@ -480,7 +480,7 @@ nocachegetattr(HeapTuple tuple,
 		 * If we get here, there are no nulls up to and including the target
 		 * attribute.  If we have a cached offset, we can use it.
 		 */
-		att = TupleDescAttr(tupleDesc, attnum);
+		att = TupleDescAttr(tupleDesc, attphysnum);
 		if (att->attcacheoff >= 0)
 			return fetchatt(att, tp + att->attcacheoff);
 
@@ -493,7 +493,7 @@ nocachegetattr(HeapTuple tuple,
 		{
 			int			j;
 
-			for (j = 0; j <= attnum; j++)
+			for (j = 0; j <= attphysnum; j++)
 			{
 				if (TupleDescAttr(tupleDesc, j)->attlen <= 0)
 				{
@@ -541,9 +541,9 @@ nocachegetattr(HeapTuple tuple,
 			off += att->attlen;
 		}
 
-		Assert(j > attnum);
+		Assert(j > attphysnum);
 
-		off = TupleDescAttr(tupleDesc, attnum)->attcacheoff;
+		off = TupleDescAttr(tupleDesc, attphysnum)->attcacheoff;
 	}
 	else
 	{
@@ -601,7 +601,7 @@ nocachegetattr(HeapTuple tuple,
 					att->attcacheoff = off;
 			}
 
-			if (i == attnum)
+			if (i == attphysnum)
 				break;
 
 			off = att_addlength_pointer(off, att->attlen, tp + off);
@@ -611,7 +611,7 @@ nocachegetattr(HeapTuple tuple,
 		}
 	}
 
-	return fetchatt(TupleDescAttr(tupleDesc, attnum), tp + off);
+	return fetchatt(TupleDescAttr(tupleDesc, attphysnum), tp + off);
 }
 
 /* ----------------
@@ -620,11 +620,11 @@ nocachegetattr(HeapTuple tuple,
  *		Fetch the value of a system attribute for a tuple.
  *
  * This is a support routine for the heap_getattr macro.  The macro
- * has already determined that the attnum refers to a system attribute.
+ * has already determined that the attphysnum refers to a system attribute.
  * ----------------
  */
 Datum
-heap_getsysattr(HeapTuple tup, int attnum, TupleDesc tupleDesc, bool *isnull)
+heap_getsysattr(HeapTuple tup, int attphysnum, TupleDesc tupleDesc, bool *isnull)
 {
 	Datum		result;
 
@@ -633,7 +633,7 @@ heap_getsysattr(HeapTuple tup, int attnum, TupleDesc tupleDesc, bool *isnull)
 	/* Currently, no sys attribute ever reads as NULL. */
 	*isnull = false;
 
-	switch (attnum)
+	switch (attphysnum)
 	{
 		case SelfItemPointerAttributeNumber:
 			/* pass-by-reference datatype */
@@ -660,7 +660,7 @@ heap_getsysattr(HeapTuple tup, int attnum, TupleDesc tupleDesc, bool *isnull)
 			result = ObjectIdGetDatum(tup->t_tableOid);
 			break;
 		default:
-			elog(ERROR, "invalid attnum: %d", attnum);
+			elog(ERROR, "invalid attphysnum: %d", attphysnum);
 			result = 0;			/* keep compiler quiet */
 			break;
 	}
@@ -735,7 +735,7 @@ expand_tuple(HeapTuple *targetHeapTuple,
 			 TupleDesc tupleDesc)
 {
 	AttrMissing *attrmiss = NULL;
-	int			attnum;
+	int			attphysnum;
 	int			firstmissingnum;
 	bool		hasNulls = HeapTupleHasNulls(sourceTuple);
 	HeapTupleHeader targetTHeader;
@@ -790,22 +790,22 @@ expand_tuple(HeapTuple *targetHeapTuple,
 		 * Now walk the missing attributes. If there is a missing value make
 		 * space for it. Otherwise, it's going to be NULL.
 		 */
-		for (attnum = firstmissingnum;
-			 attnum < natts;
-			 attnum++)
+		for (attphysnum = firstmissingnum;
+			 attphysnum < natts;
+			 attphysnum++)
 		{
-			if (attrmiss[attnum].am_present)
+			if (attrmiss[attphysnum].am_present)
 			{
-				Form_pg_attribute att = TupleDescAttr(tupleDesc, attnum);
+				Form_pg_attribute att = TupleDescAttr(tupleDesc, attphysnum);
 
 				targetDataLen = att_align_datum(targetDataLen,
 												att->attalign,
 												att->attlen,
-												attrmiss[attnum].am_value);
+												attrmiss[attphysnum].am_value);
 
 				targetDataLen = att_addlength_pointer(targetDataLen,
 													  att->attlen,
-													  attrmiss[attnum].am_value);
+													  attrmiss[attphysnum].am_value);
 			}
 			else
 			{
@@ -922,19 +922,19 @@ expand_tuple(HeapTuple *targetHeapTuple,
 	targetData += sourceDataLen;
 
 	/* Now fill in the missing values */
-	for (attnum = sourceNatts; attnum < natts; attnum++)
+	for (attphysnum = sourceNatts; attphysnum < natts; attphysnum++)
 	{
 
-		Form_pg_attribute attr = TupleDescAttr(tupleDesc, attnum);
+		Form_pg_attribute attr = TupleDescAttr(tupleDesc, attphysnum);
 
-		if (attrmiss && attrmiss[attnum].am_present)
+		if (attrmiss && attrmiss[attphysnum].am_present)
 		{
 			fill_val(attr,
 					 nullBits ? &nullBits : NULL,
 					 &bitMask,
 					 &targetData,
 					 infoMask,
-					 attrmiss[attnum].am_value,
+					 attrmiss[attphysnum].am_value,
 					 false);
 		}
 		else
@@ -1202,12 +1202,12 @@ heap_modify_tuple_by_cols(HeapTuple tuple,
 
 	for (i = 0; i < nCols; i++)
 	{
-		int			attnum = replCols[i];
+		int			attphysnum = replCols[i];
 
-		if (attnum <= 0 || attnum > numberOfAttributes)
-			elog(ERROR, "invalid column number %d", attnum);
-		values[attnum - 1] = replValues[i];
-		isnull[attnum - 1] = replIsnull[i];
+		if (attphysnum <= 0 || attphysnum > numberOfAttributes)
+			elog(ERROR, "invalid column number %d", attphysnum);
+		values[attphysnum - 1] = replValues[i];
+		isnull[attphysnum - 1] = replIsnull[i];
 	}
 
 	/*
@@ -1253,7 +1253,7 @@ heap_deform_tuple(HeapTuple tuple, TupleDesc tupleDesc,
 	bool		hasnulls = HeapTupleHasNulls(tuple);
 	int			tdesc_natts = tupleDesc->natts;
 	int			natts;			/* number of atts to extract */
-	int			attnum;
+	int			attphysnum;
 	char	   *tp;				/* ptr to tuple data */
 	uint32		off;			/* offset in tuple data */
 	bits8	   *bp = tup->t_bits;	/* ptr to null bitmap in tuple */
@@ -1272,19 +1272,19 @@ heap_deform_tuple(HeapTuple tuple, TupleDesc tupleDesc,
 
 	off = 0;
 
-	for (attnum = 0; attnum < natts; attnum++)
+	for (attphysnum = 0; attphysnum < natts; attphysnum++)
 	{
-		Form_pg_attribute thisatt = TupleDescAttr(tupleDesc, attnum);
+		Form_pg_attribute thisatt = TupleDescAttr(tupleDesc, attphysnum);
 
-		if (hasnulls && att_isnull(attnum, bp))
+		if (hasnulls && att_isnull(attphysnum, bp))
 		{
-			values[attnum] = (Datum) 0;
-			isnull[attnum] = true;
+			values[attphysnum] = (Datum) 0;
+			isnull[attphysnum] = true;
 			slow = true;		/* can't use attcacheoff anymore */
 			continue;
 		}
 
-		isnull[attnum] = false;
+		isnull[attphysnum] = false;
 
 		if (!slow && thisatt->attcacheoff >= 0)
 			off = thisatt->attcacheoff;
@@ -1315,7 +1315,7 @@ heap_deform_tuple(HeapTuple tuple, TupleDesc tupleDesc,
 				thisatt->attcacheoff = off;
 		}
 
-		values[attnum] = fetchatt(thisatt, tp + off);
+		values[attphysnum] = fetchatt(thisatt, tp + off);
 
 		off = att_addlength_pointer(off, thisatt->attlen, tp + off);
 
@@ -1327,8 +1327,8 @@ heap_deform_tuple(HeapTuple tuple, TupleDesc tupleDesc,
 	 * If tuple doesn't have all the atts indicated by tupleDesc, read the
 	 * rest as nulls or missing values as appropriate.
 	 */
-	for (; attnum < tdesc_natts; attnum++)
-		values[attnum] = getmissingattr(tupleDesc, attnum + 1, &isnull[attnum]);
+	for (; attphysnum < tdesc_natts; attphysnum++)
+		values[attphysnum] = getmissingattr(tupleDesc, attphysnum + 1, &isnull[attphysnum]);
 }
 
 /*
diff --git a/src/backend/access/common/indextuple.c b/src/backend/access/common/indextuple.c
index 3065730bae..126bc93e1c 100644
--- a/src/backend/access/common/indextuple.c
+++ b/src/backend/access/common/indextuple.c
@@ -220,7 +220,7 @@ index_form_tuple(TupleDesc tupleDescriptor,
  */
 Datum
 nocache_index_getattr(IndexTuple tup,
-					  int attnum,
+					  int attphysnum,
 					  TupleDesc tupleDesc)
 {
 	char	   *tp;				/* ptr to data part of tuple */
@@ -240,7 +240,7 @@ nocache_index_getattr(IndexTuple tup,
 
 	data_off = IndexInfoFindDataOffset(tup->t_info);
 
-	attnum--;
+	attphysnum--;
 
 	if (IndexTupleHasNulls(tup))
 	{
@@ -257,8 +257,8 @@ nocache_index_getattr(IndexTuple tup,
 		 * Now check to see if any preceding bits are null...
 		 */
 		{
-			int			byte = attnum >> 3;
-			int			finalbit = attnum & 0x07;
+			int			byte = attphysnum >> 3;
+			int			finalbit = attphysnum & 0x07;
 
 			/* check for nulls "before" final bit of last byte */
 			if ((~bp[byte]) & ((1 << finalbit) - 1))
@@ -290,7 +290,7 @@ nocache_index_getattr(IndexTuple tup,
 		 * If we get here, there are no nulls up to and including the target
 		 * attribute.  If we have a cached offset, we can use it.
 		 */
-		att = TupleDescAttr(tupleDesc, attnum);
+		att = TupleDescAttr(tupleDesc, attphysnum);
 		if (att->attcacheoff >= 0)
 			return fetchatt(att, tp + att->attcacheoff);
 
@@ -303,7 +303,7 @@ nocache_index_getattr(IndexTuple tup,
 		{
 			int			j;
 
-			for (j = 0; j <= attnum; j++)
+			for (j = 0; j <= attphysnum; j++)
 			{
 				if (TupleDescAttr(tupleDesc, j)->attlen <= 0)
 				{
@@ -351,9 +351,9 @@ nocache_index_getattr(IndexTuple tup,
 			off += att->attlen;
 		}
 
-		Assert(j > attnum);
+		Assert(j > attphysnum);
 
-		off = TupleDescAttr(tupleDesc, attnum)->attcacheoff;
+		off = TupleDescAttr(tupleDesc, attphysnum)->attcacheoff;
 	}
 	else
 	{
@@ -411,7 +411,7 @@ nocache_index_getattr(IndexTuple tup,
 					att->attcacheoff = off;
 			}
 
-			if (i == attnum)
+			if (i == attphysnum)
 				break;
 
 			off = att_addlength_pointer(off, att->attlen, tp + off);
@@ -421,7 +421,7 @@ nocache_index_getattr(IndexTuple tup,
 		}
 	}
 
-	return fetchatt(TupleDescAttr(tupleDesc, attnum), tp + off);
+	return fetchatt(TupleDescAttr(tupleDesc, attphysnum), tp + off);
 }
 
 /*
@@ -462,26 +462,26 @@ index_deform_tuple_internal(TupleDesc tupleDescriptor,
 							char *tp, bits8 *bp, int hasnulls)
 {
 	int			natts = tupleDescriptor->natts; /* number of atts to extract */
-	int			attnum;
+	int			attphysnum;
 	int			off = 0;		/* offset in tuple data */
 	bool		slow = false;	/* can we use/set attcacheoff? */
 
 	/* Assert to protect callers who allocate fixed-size arrays */
 	Assert(natts <= INDEX_MAX_KEYS);
 
-	for (attnum = 0; attnum < natts; attnum++)
+	for (attphysnum = 0; attphysnum < natts; attphysnum++)
 	{
-		Form_pg_attribute thisatt = TupleDescAttr(tupleDescriptor, attnum);
+		Form_pg_attribute thisatt = TupleDescAttr(tupleDescriptor, attphysnum);
 
-		if (hasnulls && att_isnull(attnum, bp))
+		if (hasnulls && att_isnull(attphysnum, bp))
 		{
-			values[attnum] = (Datum) 0;
-			isnull[attnum] = true;
+			values[attphysnum] = (Datum) 0;
+			isnull[attphysnum] = true;
 			slow = true;		/* can't use attcacheoff anymore */
 			continue;
 		}
 
-		isnull[attnum] = false;
+		isnull[attphysnum] = false;
 
 		if (!slow && thisatt->attcacheoff >= 0)
 			off = thisatt->attcacheoff;
@@ -512,7 +512,7 @@ index_deform_tuple_internal(TupleDesc tupleDescriptor,
 				thisatt->attcacheoff = off;
 		}
 
-		values[attnum] = fetchatt(thisatt, tp + off);
+		values[attphysnum] = fetchatt(thisatt, tp + off);
 
 		off = att_addlength_pointer(off, thisatt->attlen, tp + off);
 
diff --git a/src/backend/access/common/printsimple.c b/src/backend/access/common/printsimple.c
index e99aa279f6..8c8b85ed63 100644
--- a/src/backend/access/common/printsimple.c
+++ b/src/backend/access/common/printsimple.c
@@ -41,7 +41,7 @@ printsimple_startup(DestReceiver *self, int operation, TupleDesc tupdesc)
 
 		pq_sendstring(&buf, NameStr(attr->attname));
 		pq_sendint32(&buf, 0);	/* table oid */
-		pq_sendint16(&buf, 0);	/* attnum */
+		pq_sendint16(&buf, 0);	/* attphysnum */
 		pq_sendint32(&buf, (int) attr->atttypid);
 		pq_sendint16(&buf, attr->attlen);
 		pq_sendint32(&buf, attr->atttypmod);
diff --git a/src/backend/access/common/tupdesc.c b/src/backend/access/common/tupdesc.c
index 9f41b1e854..409a93ccdf 100644
--- a/src/backend/access/common/tupdesc.c
+++ b/src/backend/access/common/tupdesc.c
@@ -291,7 +291,7 @@ TupleDescCopyEntry(TupleDesc dst, AttrNumber dstAttno,
 	 * by other uses of this function or TupleDescInitEntry.  So we cheat a
 	 * bit to avoid a useless O(N^2) penalty.
 	 */
-	dstAtt->attnum = dstAttno;
+	dstAtt->attphysnum = dstAttno;
 	dstAtt->attcacheoff = -1;
 
 	/* since we're not copying constraints or defaults, clear these */
@@ -416,7 +416,7 @@ equalTupleDescs(TupleDesc tupdesc1, TupleDesc tupdesc2)
 
 		/*
 		 * We do not need to check every single field here: we can disregard
-		 * attrelid and attnum (which were used to place the row in the attrs
+		 * attrelid and attphysnum (which were used to place the row in the attrs
 		 * array in the first place).  It might look like we could dispense
 		 * with checking attlen/attbyval/attalign, since these are derived
 		 * from atttypid; but in the case of dropped columns we must check
@@ -619,7 +619,7 @@ TupleDescInitEntry(TupleDesc desc,
 	att->attcacheoff = -1;
 	att->atttypmod = typmod;
 
-	att->attnum = attributeNumber;
+	att->attphysnum = attributeNumber;
 	att->attndims = attdim;
 
 	att->attnotnull = false;
@@ -680,7 +680,7 @@ TupleDescInitBuiltinEntry(TupleDesc desc,
 	att->attcacheoff = -1;
 	att->atttypmod = typmod;
 
-	att->attnum = attributeNumber;
+	att->attphysnum = attributeNumber;
 	att->attndims = attdim;
 
 	att->attnotnull = false;
@@ -777,7 +777,7 @@ TupleDesc
 BuildDescForRelation(List *schema)
 {
 	int			natts;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	ListCell   *l;
 	TupleDesc	desc;
 	bool		has_not_null;
@@ -794,7 +794,7 @@ BuildDescForRelation(List *schema)
 	desc = CreateTemplateTupleDesc(natts);
 	has_not_null = false;
 
-	attnum = 0;
+	attphysnum = 0;
 
 	foreach(l, schema)
 	{
@@ -807,7 +807,7 @@ BuildDescForRelation(List *schema)
 		 * the list and have TupleDescInitEntry fill in the attribute
 		 * information we need.
 		 */
-		attnum++;
+		attphysnum++;
 
 		attname = entry->colname;
 		typenameTypeIdAndMod(NULL, entry->typeName, &atttypid, &atttypmod);
@@ -825,12 +825,12 @@ BuildDescForRelation(List *schema)
 					 errmsg("column \"%s\" cannot be declared SETOF",
 							attname)));
 
-		TupleDescInitEntry(desc, attnum, attname,
+		TupleDescInitEntry(desc, attphysnum, attname,
 						   atttypid, atttypmod, attdim);
-		att = TupleDescAttr(desc, attnum - 1);
+		att = TupleDescAttr(desc, attphysnum - 1);
 
 		/* Override TupleDescInitEntry's settings as requested */
-		TupleDescInitEntryCollation(desc, attnum, attcollation);
+		TupleDescInitEntryCollation(desc, attphysnum, attcollation);
 		if (entry->storage)
 			att->attstorage = entry->storage;
 
@@ -877,7 +877,7 @@ TupleDesc
 BuildDescFromLists(List *names, List *types, List *typmods, List *collations)
 {
 	int			natts;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	ListCell   *l1;
 	ListCell   *l2;
 	ListCell   *l3;
@@ -894,7 +894,7 @@ BuildDescFromLists(List *names, List *types, List *typmods, List *collations)
 	 */
 	desc = CreateTemplateTupleDesc(natts);
 
-	attnum = 0;
+	attphysnum = 0;
 	forfour(l1, names, l2, types, l3, typmods, l4, collations)
 	{
 		char	   *attname = strVal(lfirst(l1));
@@ -902,10 +902,10 @@ BuildDescFromLists(List *names, List *types, List *typmods, List *collations)
 		int32		atttypmod = lfirst_int(l3);
 		Oid			attcollation = lfirst_oid(l4);
 
-		attnum++;
+		attphysnum++;
 
-		TupleDescInitEntry(desc, attnum, attname, atttypid, atttypmod, 0);
-		TupleDescInitEntryCollation(desc, attnum, attcollation);
+		TupleDescInitEntry(desc, attphysnum, attname, atttypid, atttypmod, 0);
+		TupleDescInitEntryCollation(desc, attphysnum, attcollation);
 	}
 
 	return desc;
diff --git a/src/backend/access/gin/ginbulk.c b/src/backend/access/gin/ginbulk.c
index 0d0da44694..2ce4301250 100644
--- a/src/backend/access/gin/ginbulk.c
+++ b/src/backend/access/gin/ginbulk.c
@@ -76,8 +76,8 @@ cmpEntryAccumulator(const RBTNode *a, const RBTNode *b, void *arg)
 	BuildAccumulator *accum = (BuildAccumulator *) arg;
 
 	return ginCompareAttEntries(accum->ginstate,
-								ea->attnum, ea->key, ea->category,
-								eb->attnum, eb->key, eb->category);
+								ea->attphysnum, ea->key, ea->category,
+								eb->attphysnum, eb->key, eb->category);
 }
 
 /* Allocator function for rbtree.c */
@@ -125,12 +125,12 @@ ginInitBA(BuildAccumulator *accum)
  * palloc'd space in accum->allocatedMemory.
  */
 static Datum
-getDatumCopy(BuildAccumulator *accum, OffsetNumber attnum, Datum value)
+getDatumCopy(BuildAccumulator *accum, OffsetNumber attphysnum, Datum value)
 {
 	Form_pg_attribute att;
 	Datum		res;
 
-	att = TupleDescAttr(accum->ginstate->origTupdesc, attnum - 1);
+	att = TupleDescAttr(accum->ginstate->origTupdesc, attphysnum - 1);
 	if (att->attbyval)
 		res = value;
 	else
@@ -146,7 +146,7 @@ getDatumCopy(BuildAccumulator *accum, OffsetNumber attnum, Datum value)
  */
 static void
 ginInsertBAEntry(BuildAccumulator *accum,
-				 ItemPointer heapptr, OffsetNumber attnum,
+				 ItemPointer heapptr, OffsetNumber attphysnum,
 				 Datum key, GinNullCategory category)
 {
 	GinEntryAccumulator eatmp;
@@ -157,7 +157,7 @@ ginInsertBAEntry(BuildAccumulator *accum,
 	 * For the moment, fill only the fields of eatmp that will be looked at by
 	 * cmpEntryAccumulator or ginCombineData.
 	 */
-	eatmp.attnum = attnum;
+	eatmp.attphysnum = attphysnum;
 	eatmp.key = key;
 	eatmp.category = category;
 	/* temporarily set up single-entry itempointer list */
@@ -173,7 +173,7 @@ ginInsertBAEntry(BuildAccumulator *accum,
 		 * copies of the datum (if it's not null) and itempointer.
 		 */
 		if (category == GIN_CAT_NORM_KEY)
-			ea->key = getDatumCopy(accum, attnum, key);
+			ea->key = getDatumCopy(accum, attphysnum, key);
 		ea->maxcount = DEF_NPTR;
 		ea->count = 1;
 		ea->shouldSort = false;
@@ -208,7 +208,7 @@ ginInsertBAEntry(BuildAccumulator *accum,
  */
 void
 ginInsertBAEntries(BuildAccumulator *accum,
-				   ItemPointer heapptr, OffsetNumber attnum,
+				   ItemPointer heapptr, OffsetNumber attphysnum,
 				   Datum *entries, GinNullCategory *categories,
 				   int32 nentries)
 {
@@ -217,7 +217,7 @@ ginInsertBAEntries(BuildAccumulator *accum,
 	if (nentries <= 0)
 		return;
 
-	Assert(ItemPointerIsValid(heapptr) && attnum >= FirstOffsetNumber);
+	Assert(ItemPointerIsValid(heapptr) && attphysnum >= FirstOffsetNumber);
 
 	/*
 	 * step will contain largest power of 2 and <= nentries
@@ -235,7 +235,7 @@ ginInsertBAEntries(BuildAccumulator *accum,
 		int			i;
 
 		for (i = step - 1; i < nentries && i >= 0; i += step << 1 /* *2 */ )
-			ginInsertBAEntry(accum, heapptr, attnum,
+			ginInsertBAEntry(accum, heapptr, attphysnum,
 							 entries[i], categories[i]);
 
 		step >>= 1;				/* /2 */
@@ -266,7 +266,7 @@ ginBeginBAScan(BuildAccumulator *accum)
  */
 ItemPointerData *
 ginGetBAEntry(BuildAccumulator *accum,
-			  OffsetNumber *attnum, Datum *key, GinNullCategory *category,
+			  OffsetNumber *attphysnum, Datum *key, GinNullCategory *category,
 			  uint32 *n)
 {
 	GinEntryAccumulator *entry;
@@ -277,7 +277,7 @@ ginGetBAEntry(BuildAccumulator *accum,
 	if (entry == NULL)
 		return NULL;			/* no more entries */
 
-	*attnum = entry->attnum;
+	*attphysnum = entry->attphysnum;
 	*key = entry->key;
 	*category = entry->category;
 	list = entry->list;
diff --git a/src/backend/access/gin/ginentrypage.c b/src/backend/access/gin/ginentrypage.c
index 382f8bb4d6..3b6c2300a3 100644
--- a/src/backend/access/gin/ginentrypage.c
+++ b/src/backend/access/gin/ginentrypage.c
@@ -43,7 +43,7 @@ static void entrySplitPage(GinBtree btree, Buffer origbuf,
  */
 IndexTuple
 GinFormTuple(GinState *ginstate,
-			 OffsetNumber attnum, Datum key, GinNullCategory category,
+			 OffsetNumber attphysnum, Datum key, GinNullCategory category,
 			 Pointer data, Size dataSize, int nipd,
 			 bool errorTooBig)
 {
@@ -60,13 +60,13 @@ GinFormTuple(GinState *ginstate,
 	}
 	else
 	{
-		datums[0] = UInt16GetDatum(attnum);
+		datums[0] = UInt16GetDatum(attphysnum);
 		isnull[0] = false;
 		datums[1] = key;
 		isnull[1] = (category != GIN_CAT_NORM_KEY);
 	}
 
-	itup = index_form_tuple(ginstate->tupdesc[attnum - 1], datums, isnull);
+	itup = index_form_tuple(ginstate->tupdesc[attphysnum - 1], datums, isnull);
 
 	/*
 	 * Determine and store offset to the posting list, making sure there is
@@ -160,7 +160,7 @@ GinFormTuple(GinState *ginstate,
  * in *nitems.
  */
 ItemPointer
-ginReadTuple(GinState *ginstate, OffsetNumber attnum, IndexTuple itup,
+ginReadTuple(GinState *ginstate, OffsetNumber attphysnum, IndexTuple itup,
 			 int *nitems)
 {
 	Pointer		ptr = GinGetPosting(itup);
@@ -244,7 +244,7 @@ static bool
 entryIsMoveRight(GinBtree btree, Page page)
 {
 	IndexTuple	itup;
-	OffsetNumber attnum;
+	OffsetNumber attphysnum;
 	Datum		key;
 	GinNullCategory category;
 
@@ -252,12 +252,12 @@ entryIsMoveRight(GinBtree btree, Page page)
 		return false;
 
 	itup = getRightMostTuple(page);
-	attnum = gintuple_get_attrnum(btree->ginstate, itup);
+	attphysnum = gintuple_get_attrnum(btree->ginstate, itup);
 	key = gintuple_get_key(btree->ginstate, itup, &category);
 
 	if (ginCompareAttEntries(btree->ginstate,
 							 btree->entryAttnum, btree->entryKey, btree->entryCategory,
-							 attnum, key, category) > 0)
+							 attphysnum, key, category) > 0)
 		return true;
 
 	return false;
@@ -304,18 +304,18 @@ entryLocateEntry(GinBtree btree, GinBtreeStack *stack)
 		}
 		else
 		{
-			OffsetNumber attnum;
+			OffsetNumber attphysnum;
 			Datum		key;
 			GinNullCategory category;
 
 			itup = (IndexTuple) PageGetItem(page, PageGetItemId(page, mid));
-			attnum = gintuple_get_attrnum(btree->ginstate, itup);
+			attphysnum = gintuple_get_attrnum(btree->ginstate, itup);
 			key = gintuple_get_key(btree->ginstate, itup, &category);
 			result = ginCompareAttEntries(btree->ginstate,
 										  btree->entryAttnum,
 										  btree->entryKey,
 										  btree->entryCategory,
-										  attnum, key, category);
+										  attphysnum, key, category);
 		}
 
 		if (result == 0)
@@ -374,19 +374,19 @@ entryLocateLeafEntry(GinBtree btree, GinBtreeStack *stack)
 	{
 		OffsetNumber mid = low + ((high - low) / 2);
 		IndexTuple	itup;
-		OffsetNumber attnum;
+		OffsetNumber attphysnum;
 		Datum		key;
 		GinNullCategory category;
 		int			result;
 
 		itup = (IndexTuple) PageGetItem(page, PageGetItemId(page, mid));
-		attnum = gintuple_get_attrnum(btree->ginstate, itup);
+		attphysnum = gintuple_get_attrnum(btree->ginstate, itup);
 		key = gintuple_get_key(btree->ginstate, itup, &category);
 		result = ginCompareAttEntries(btree->ginstate,
 									  btree->entryAttnum,
 									  btree->entryKey,
 									  btree->entryCategory,
-									  attnum, key, category);
+									  attphysnum, key, category);
 		if (result == 0)
 		{
 			stack->off = mid;
@@ -742,7 +742,7 @@ ginEntryFillRoot(GinBtree btree, Page root,
  * other than a faked-up Relation pointer; the key datum is bogus too.
  */
 void
-ginPrepareEntryScan(GinBtree btree, OffsetNumber attnum,
+ginPrepareEntryScan(GinBtree btree, OffsetNumber attphysnum,
 					Datum key, GinNullCategory category,
 					GinState *ginstate)
 {
@@ -766,7 +766,7 @@ ginPrepareEntryScan(GinBtree btree, OffsetNumber attnum,
 	btree->fullScan = false;
 	btree->isBuild = false;
 
-	btree->entryAttnum = attnum;
+	btree->entryAttnum = attphysnum;
 	btree->entryKey = key;
 	btree->entryCategory = category;
 }
diff --git a/src/backend/access/gin/ginfast.c b/src/backend/access/gin/ginfast.c
index 7409fdc165..2a50a55fbc 100644
--- a/src/backend/access/gin/ginfast.c
+++ b/src/backend/access/gin/ginfast.c
@@ -473,7 +473,7 @@ ginHeapTupleFastInsert(GinState *ginstate, GinTupleCollector *collector)
 void
 ginHeapTupleFastCollect(GinState *ginstate,
 						GinTupleCollector *collector,
-						OffsetNumber attnum, Datum value, bool isNull,
+						OffsetNumber attphysnum, Datum value, bool isNull,
 						ItemPointer ht_ctid)
 {
 	Datum	   *entries;
@@ -484,7 +484,7 @@ ginHeapTupleFastCollect(GinState *ginstate,
 	/*
 	 * Extract the key values that need to be inserted in the index
 	 */
-	entries = ginExtractEntries(ginstate, attnum, value, isNull,
+	entries = ginExtractEntries(ginstate, attphysnum, value, isNull,
 								&nentries, &categories);
 
 	/*
@@ -527,7 +527,7 @@ ginHeapTupleFastCollect(GinState *ginstate,
 	{
 		IndexTuple	itup;
 
-		itup = GinFormTuple(ginstate, attnum, entries[i], categories[i],
+		itup = GinFormTuple(ginstate, attphysnum, entries[i], categories[i],
 							NULL, 0, 0, true);
 		itup->t_tid = *ht_ctid;
 		collector->tuples[collector->ntuples++] = itup;
@@ -723,7 +723,7 @@ processPendingPage(BuildAccumulator *accum, KeyArray *ka,
 		Datum		curkey;
 		GinNullCategory curcategory;
 
-		/* Check for change of heap TID or attnum */
+		/* Check for change of heap TID or attphysnum */
 		curattnum = gintuple_get_attrnum(accum->ginstate, itup);
 
 		if (!ItemPointerIsValid(&heapptr))
@@ -902,7 +902,7 @@ ginInsertCleanup(GinState *ginstate, bool full_clean,
 			Datum		key;
 			GinNullCategory category;
 			OffsetNumber maxoff,
-						attnum;
+						attphysnum;
 
 			/*
 			 * Unlock current page to increase performance. Changes of page
@@ -919,9 +919,9 @@ ginInsertCleanup(GinState *ginstate, bool full_clean,
 			 */
 			ginBeginBAScan(&accum);
 			while ((list = ginGetBAEntry(&accum,
-										 &attnum, &key, &category, &nlist)) != NULL)
+										 &attphysnum, &key, &category, &nlist)) != NULL)
 			{
-				ginEntryInsert(ginstate, attnum, key, category,
+				ginEntryInsert(ginstate, attphysnum, key, category,
 							   list, nlist, NULL);
 				vacuum_delay_point();
 			}
@@ -949,8 +949,8 @@ ginInsertCleanup(GinState *ginstate, bool full_clean,
 
 				ginBeginBAScan(&accum);
 				while ((list = ginGetBAEntry(&accum,
-											 &attnum, &key, &category, &nlist)) != NULL)
-					ginEntryInsert(ginstate, attnum, key, category,
+											 &attphysnum, &key, &category, &nlist)) != NULL)
+					ginEntryInsert(ginstate, attphysnum, key, category,
 								   list, nlist, NULL);
 			}
 
